diff --git a/src/include/utils/relcache.h b/src/include/utils/relcache.h
new file mode 100644
index 6953281..e686c9e
*** a/src/include/utils/relcache.h
--- b/src/include/utils/relcache.h
***************
*** 19,24 ****
--- 19,27 ----
  
  
  typedef struct RelationData *Relation;
+ typedef struct IndexPath IndexPath;
+ typedef struct IndexInfo IndexInfo;
+ 
  
  /* ----------------
   *		RelationPtr is used in the executor to support index scans
*************** typedef struct RelationData *Relation;
*** 28,33 ****
--- 31,45 ----
   */
  typedef Relation *RelationPtr;
  
+ typedef struct IndexAmRoutine IndexAmRoutine;
+ 
+ /*
+  * Routines to retreive IndexAmRoutine
+  */
+ extern IndexAmRoutine *GetIndexAmRoutine(Oid amhandler);
+ extern IndexAmRoutine *GetIndexAmRoutineByAmId(Oid amoid);
+ extern void InitIndexAmRoutine(Relation relation);
+ 
  /*
   * Routines to open (lookup) and close a relcache entry
   */
diff --git a/src/include/utils/selfuncs.h b/src/include/utils/selfuncs.h
new file mode 100644
index a7433d9..3745d1c
*** a/src/include/utils/selfuncs.h
--- b/src/include/utils/selfuncs.h
*************** extern double estimate_num_groups(Planne
*** 191,202 ****
  extern Selectivity estimate_hash_bucketsize(PlannerInfo *root, Node *hashkey,
  						 double nbuckets);
  
! extern Datum brincostestimate(PG_FUNCTION_ARGS);
! extern Datum btcostestimate(PG_FUNCTION_ARGS);
! extern Datum hashcostestimate(PG_FUNCTION_ARGS);
! extern Datum gistcostestimate(PG_FUNCTION_ARGS);
! extern Datum spgcostestimate(PG_FUNCTION_ARGS);
! extern Datum gincostestimate(PG_FUNCTION_ARGS);
  
  /* Functions in array_selfuncs.c */
  
--- 191,226 ----
  extern Selectivity estimate_hash_bucketsize(PlannerInfo *root, Node *hashkey,
  						 double nbuckets);
  
! extern void brincostestimate(PlannerInfo *root, IndexPath *path,
! 							 double loop_count, Cost *indexStartupCost,
! 							 Cost *indexTotalCost,
! 							 Selectivity *indexSelectivity,
! 							 double *indexCorrelation);
! extern void btcostestimate(PlannerInfo *root, IndexPath *path,
! 						   double loop_count, Cost *indexStartupCost,
! 						   Cost *indexTotalCost,
! 						   Selectivity *indexSelectivity,
! 						   double *indexCorrelation);
! extern void hashcostestimate(PlannerInfo *root, IndexPath *path,
! 							 double loop_count, Cost *indexStartupCost,
! 							 Cost *indexTotalCost,
! 							 Selectivity *indexSelectivity,
! 							 double *indexCorrelation);
! extern void gistcostestimate(PlannerInfo *root, IndexPath *path,
! 							 double loop_count, Cost *indexStartupCost,
! 							 Cost *indexTotalCost,
! 							 Selectivity *indexSelectivity,
! 							 double *indexCorrelation);
! extern void spgcostestimate(PlannerInfo *root, IndexPath *path,
! 							double loop_count, Cost *indexStartupCost,
! 							Cost *indexTotalCost,
! 							Selectivity *indexSelectivity,
! 							double *indexCorrelation);
! extern void gincostestimate(PlannerInfo *root, IndexPath *path,
! 							double loop_count, Cost *indexStartupCost,
! 							Cost *indexTotalCost,
! 							Selectivity *indexSelectivity,
! 							double *indexCorrelation);
  
  /* Functions in array_selfuncs.c */
  
diff --git a/src/test/regress/sql/alter_table.sql b/src/test/regress/sql/alter_table.sql
new file mode 100644
index 778791d..a426ef5
*** a/src/test/regress/sql/alter_table.sql
--- b/src/test/regress/sql/alter_table.sql
*************** as 'select $1.f1 is not distinct from $2
*** 1452,1459 ****
  
  create operator alter1.=(procedure = alter1.same, leftarg  = alter1.ctype, rightarg = alter1.ctype);
  
  create operator class alter1.ctype_hash_ops default for type alter1.ctype using hash as
!   operator 1 alter1.=(alter1.ctype, alter1.ctype);
  
  create conversion alter1.ascii_to_utf8 for 'sql_ascii' to 'utf8' from ascii_to_utf8;
  
--- 1452,1463 ----
  
  create operator alter1.=(procedure = alter1.same, leftarg  = alter1.ctype, rightarg = alter1.ctype);
  
+ create function alter1.hash(alter1.ctype) returns int4 language sql
+ as 'select hashint4($1.f1) # hashtext($1.f2)';
+ 
  create operator class alter1.ctype_hash_ops default for type alter1.ctype using hash as
!   operator 1 alter1.=(alter1.ctype, alter1.ctype),
!   function 1 alter1.hash(alter1.ctype);
  
  create conversion alter1.ascii_to_utf8 for 'sql_ascii' to 'utf8' from ascii_to_utf8;
  
*************** alter operator class alter1.ctype_hash_o
*** 1473,1478 ****
--- 1477,1483 ----
  alter operator family alter1.ctype_hash_ops using hash set schema alter2;
  alter operator alter1.=(alter1.ctype, alter1.ctype) set schema alter2;
  alter function alter1.same(alter1.ctype, alter1.ctype) set schema alter2;
+ alter function alter1.hash(alter1.ctype) set schema alter2;
  alter type alter1.ctype set schema alter2;
  alter conversion alter1.ascii_to_utf8 set schema alter2;
  alter text search parser alter1.prs set schema alter2;
diff --git a/src/test/regress/sql/oidjoins.sql b/src/test/regress/sql/oidjoins.sql
new file mode 100644
index 2fa628d..ca419fd
*** a/src/test/regress/sql/oidjoins.sql
--- b/src/test/regress/sql/oidjoins.sql
*************** SELECT	ctid, aggmtranstype
*** 37,106 ****
  FROM	pg_catalog.pg_aggregate fk
  WHERE	aggmtranstype != 0 AND
  	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_type pk WHERE pk.oid = fk.aggmtranstype);
- SELECT	ctid, amkeytype
- FROM	pg_catalog.pg_am fk
- WHERE	amkeytype != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_type pk WHERE pk.oid = fk.amkeytype);
- SELECT	ctid, aminsert
- FROM	pg_catalog.pg_am fk
- WHERE	aminsert != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.aminsert);
- SELECT	ctid, ambeginscan
- FROM	pg_catalog.pg_am fk
- WHERE	ambeginscan != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.ambeginscan);
- SELECT	ctid, amgettuple
- FROM	pg_catalog.pg_am fk
- WHERE	amgettuple != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amgettuple);
- SELECT	ctid, amgetbitmap
- FROM	pg_catalog.pg_am fk
- WHERE	amgetbitmap != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amgetbitmap);
- SELECT	ctid, amrescan
- FROM	pg_catalog.pg_am fk
- WHERE	amrescan != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amrescan);
- SELECT	ctid, amendscan
- FROM	pg_catalog.pg_am fk
- WHERE	amendscan != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amendscan);
- SELECT	ctid, ammarkpos
- FROM	pg_catalog.pg_am fk
- WHERE	ammarkpos != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.ammarkpos);
- SELECT	ctid, amrestrpos
- FROM	pg_catalog.pg_am fk
- WHERE	amrestrpos != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amrestrpos);
- SELECT	ctid, ambuild
- FROM	pg_catalog.pg_am fk
- WHERE	ambuild != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.ambuild);
- SELECT	ctid, ambuildempty
- FROM	pg_catalog.pg_am fk
- WHERE	ambuildempty != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.ambuildempty);
- SELECT	ctid, ambulkdelete
- FROM	pg_catalog.pg_am fk
- WHERE	ambulkdelete != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.ambulkdelete);
- SELECT	ctid, amvacuumcleanup
- FROM	pg_catalog.pg_am fk
- WHERE	amvacuumcleanup != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amvacuumcleanup);
- SELECT	ctid, amcanreturn
- FROM	pg_catalog.pg_am fk
- WHERE	amcanreturn != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amcanreturn);
- SELECT	ctid, amcostestimate
- FROM	pg_catalog.pg_am fk
- WHERE	amcostestimate != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amcostestimate);
- SELECT	ctid, amoptions
- FROM	pg_catalog.pg_am fk
- WHERE	amoptions != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amoptions);
  SELECT	ctid, amopfamily
  FROM	pg_catalog.pg_amop fk
  WHERE	amopfamily != 0 AND
--- 37,42 ----
diff --git a/src/test/regress/sql/opr_sanity.sql b/src/test/regress/sql/opr_sanity.sql
new file mode 100644
index c9bdd77..0e0506e
*** a/src/test/regress/sql/opr_sanity.sql
--- b/src/test/regress/sql/opr_sanity.sql
*************** WHERE p1.oid != p2.oid AND
*** 960,965 ****
--- 960,969 ----
      p1.opcmethod = p2.opcmethod AND p1.opcintype = p2.opcintype AND
      p1.opcdefault AND p2.opcdefault;
  
+ -- Ask access methods to validate opclasses
+ 
+ SELECT oid FROM pg_opclass WHERE NOT amvalidate(oid);
+ 
  -- **************** pg_amop ****************
  
  -- Look for illegal values in pg_amop fields
*************** WHERE p1.amopsortfamily <> 0 AND NOT EXI
*** 995,1035 ****
      (SELECT 1 from pg_opfamily op WHERE op.oid = p1.amopsortfamily
       AND op.opfmethod = (SELECT oid FROM pg_am WHERE amname = 'btree'));
  
- -- check for ordering operators not supported by parent AM
- 
- SELECT p1.amopfamily, p1.amopopr, p2.oid, p2.amname
- FROM pg_amop AS p1, pg_am AS p2
- WHERE p1.amopmethod = p2.oid AND
-     p1.amoppurpose = 'o' AND NOT p2.amcanorderbyop;
- 
- -- Cross-check amopstrategy index against parent AM
- 
- SELECT p1.amopfamily, p1.amopopr, p2.oid, p2.amname
- FROM pg_amop AS p1, pg_am AS p2
- WHERE p1.amopmethod = p2.oid AND
-     p1.amopstrategy > p2.amstrategies AND p2.amstrategies <> 0;
- 
- -- Detect missing pg_amop entries: should have as many strategy operators
- -- as AM expects for each datatype combination supported by the opfamily.
- -- We can't check this for AMs with variable strategy sets.
- 
- SELECT p1.amname, p2.amoplefttype, p2.amoprighttype
- FROM pg_am AS p1, pg_amop AS p2
- WHERE p2.amopmethod = p1.oid AND
-     p1.amstrategies <> 0 AND
-     p1.amstrategies != (SELECT count(*) FROM pg_amop AS p3
-                         WHERE p3.amopfamily = p2.amopfamily AND
-                               p3.amoplefttype = p2.amoplefttype AND
-                               p3.amoprighttype = p2.amoprighttype AND
-                               p3.amoppurpose = 's');
- 
- -- Currently, none of the AMs with fixed strategy sets support ordering ops.
- 
- SELECT p1.amname, p2.amopfamily, p2.amopstrategy
- FROM pg_am AS p1, pg_amop AS p2
- WHERE p2.amopmethod = p1.oid AND
-     p1.amstrategies <> 0 AND p2.amoppurpose <> 's';
- 
  -- Check that amopopr points at a reasonable-looking operator, ie a binary
  -- operator.  If it's a search operator it had better yield boolean,
  -- otherwise an input type of its sort opfamily.
--- 999,1004 ----
*************** FROM pg_amproc as p1
*** 1176,1188 ****
  WHERE p1.amprocfamily = 0 OR p1.amproclefttype = 0 OR p1.amprocrighttype = 0
      OR p1.amprocnum < 1 OR p1.amproc = 0;
  
- -- Cross-check amprocnum index against parent AM
- 
- SELECT p1.amprocfamily, p1.amprocnum, p2.oid, p2.amname
- FROM pg_amproc AS p1, pg_am AS p2, pg_opfamily AS p3
- WHERE p1.amprocfamily = p3.oid AND p3.opfmethod = p2.oid AND
-     p1.amprocnum > p2.amsupport;
- 
  -- Detect missing pg_amproc entries: should have as many support functions
  -- as AM expects for each datatype combination supported by the opfamily.
  
--- 1145,1150 ----
